import { I18nBaseService } from './../i18n/i18n-base-service';
export declare abstract class EnumBase<T> {
    readonly value: T;
    readonly label: string;
    readonly disabled: boolean;
    protected constructor(value: T, label: string, disabled?: boolean);
    translateLabel(i18n: I18nBaseService): string;
}
