import { ValidatorFn } from '@angular/forms';
export declare class InscricaoEstadualValidator {
    static tipoEstado(siglaEstado: string, inscricaoEstado: string): boolean;
    static validaIEAcre(inscricaoEstado: string): boolean;
    static validaIEAlagoas(inscricaoEstado: string): boolean;
    static validaIEAmapa(inscricaoEstado: string): boolean;
    static validaIEAmazonas(inscricaoEstado: string): boolean;
    static validaIEBahia(inscricaoEstado: string): boolean;
    static validaIECeara(inscricaoEstado: string): boolean;
    static validaIEEspiritoSanto(inscricaoEstado: string): boolean;
    static validaIEGoiais(inscricaoEstado: string): boolean;
    static validaIEMaranhao(inscricaoEstado: string): boolean;
    static validaIEMatoGrosso(inscricaoEstado: string): boolean;
    static validaIEMatoGrossoDoSul(inscricaoEstadual: string): boolean;
    static validaIEMinasGerais(inscricaoEstadual: string): boolean;
    static validaIEPara(inscricaoEstadual: string): boolean;
    static validaIEParaiba(inscricaoEstadual: string): boolean;
    static validaIEParana(inscricaoEstadual: string): boolean;
    static validaIEPernambuco(inscricaoEstadual: string): boolean;
    static validaIEPiaui(inscricaoEstadual: string): boolean;
    static validaIERioJaneiro(inscricaoEstadual: string): boolean;
    static validaIERioGrandeNorte(inscricaoEstado: string): boolean;
    static validaIERioGrandeSul(inscricaoEstado: string): boolean;
    static validaIERondonia(inscricaoEstado: string): boolean;
    static validaIERoraima(inscricaoEstado: string): boolean;
    static validaIESantaCatarina(inscricaoEstado: string): boolean;
    static validaIESaoPaulo(inscricaoEstado: string): boolean;
    static validaIESergipe(inscricaoEstado: string): boolean;
    static validaIETocantins(inscricaoEstado: string): boolean;
    static validaIEDistritoFederal(inscricaoEstado: string): boolean;
}
export declare const inscricaoEstadualValidator: (fnGetSiglaEstado: () => string) => ValidatorFn;
