/**
 * Interface para consulta que possibilite definir parâmetros de URL
 */
export interface IGetAllUrlParam {
    /**
     * Parâmetros de URL
     */
    urlParams: string[];
    /**
     * Método responsável por definir os parâmetros de URL para a consulta
     * @param urlParams Lista de parâmetros
     */
    setUrlParams(...urlParams: string[]): void;
}
