import { Observable } from 'rxjs';
/**
 * Classe de configuração para gerenciamento de Unidade
 */
export declare class UnidadeConfigBase {
    /** URL do serviço de domínio da Unidade */
    urlUnidade: Observable<string>;
    /** URL do serviço de query da Unidade */
    urlUnidadeQuery: Observable<string>;
    /** Rota para direcionamento quando a unidade não é encontrada */
    rotaUnidadeNaoEncontrada: string;
    /** Rota para direcionamento quando ocorre erro no servidor */
    rotaErroBuscarUnidade: string;
}
