import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
import { IGetAllPagination, IGetAllService } from 'totvs-log-base-foundation';
import { IUnidade } from '../entities/unidade.interface';
import { UnidadeConfigBase } from './../entities/unidade-config-base.entity';
export declare class UnidadeGetAllService implements IGetAllService<IUnidade>, IGetAllPagination<IUnidade> {
    private readonly httpClient;
    private mappedGetAll;
    private _urlGetAll;
    readonly urlGetAll: string;
    readonly page: number;
    readonly pageSize: number;
    readonly hasNext: boolean;
    readonly items: IUnidade[];
    constructor(httpClient: HttpClient, unidadeConfig: UnidadeConfigBase);
    reset(): Observable<IUnidade[]>;
    more(): Observable<IUnidade[]>;
    getAll(): Observable<IUnidade[]>;
}
