import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
import { IPostEntity } from 'totvs-log-base-foundation';
import { UnidadeConfigBase } from './../entities/unidade-config-base.entity';
import { IUnidade } from './../entities/unidade.interface';
export declare class UnidadeIncluirService implements IPostEntity<IUnidade, string> {
    private readonly httpClient;
    private _url;
    readonly url: string;
    private mapped;
    constructor(httpClient: HttpClient, unidadeConfig: UnidadeConfigBase);
    Post(unidade: IUnidade): Observable<string>;
}
